[CI] Added job for running dv and splitted precheck to two jobs
- precheck xor and drc checks are seperated because xor check runs for a very long amount of time on large designs
- the dv checks run the rtl simulation for now
diff --git a/.github/scripts/dv/run-dv-wrapper.sh b/.github/scripts/dv/run-dv-wrapper.sh
new file mode 100644
index 0000000..8deec88
--- /dev/null
+++ b/.github/scripts/dv/run-dv-wrapper.sh
@@ -0,0 +1,73 @@
+#!/bin/bash
+# SPDX-FileCopyrightText: 2020 Efabless Corporation
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+# SPDX-License-Identifier: Apache-2.0
+
+# comma seperated test ids
+IDS=$1
+# simulation mode : RTL/GL
+SIM_MODE=$2
+
+DV_TEST_IDS=(${IDS//,/ })
+
+export TARGET_PATH=$(pwd)
+if [ ! -d $TARGET_PATH ]
+then
+ echo "Directory /path/to/dir DOES NOT exists."
+ exit 9999
+fi
+
+cd ..
+
+export PDK_PATH=$(pwd)/pdks/sky130A
+if [ ! -d $PDK_PATH ]
+then
+ echo "Directory /path/to/dir DOES NOT exists."
+ exit 9999
+fi
+
+DV_PATH=$TARGET_PATH/verilog/dv
+if [ ! -d $DV_PATH ]
+then
+ echo "Directory /path/to/dir DOES NOT exists."
+ exit 9999
+fi
+
+for id in "${DV_TEST_IDS[@]}"
+do
+ docker run -v $TARGET_PATH:$TARGET_PATH -v $PDK_PATH:$PDK_PATH \
+ -e TARGET_PATH=$TARGET_PATH -e PDK_PATH=$PDK_PATH \
+ -u $(id -u $USER):$(id -g $USER) efabless/dv_setup:latest \
+ bash -c "bash $TARGET_PATH/.github/scripts/dv/run-dv.sh $PDK_PATH $DV_PATH $id $SIM_MODE"
+
+ echo "DONE!"
+
+ VERDICT_FILE=$TARGET_PATH/verilog/dv/$id.out
+
+ if [ -f $VERDICT_FILE ]; then
+ cnt=$(grep "Pass" $VERDICT_FILE -s | wc -l)
+ if ! [[ $cnt ]]; then cnt = 0; fi
+ else
+ echo "DV check failed due to subscript failure. Please review the logs";
+ exit 2;
+ fi
+
+ echo "Verdict: $cnt"
+
+ if [[ $cnt -ne 1 ]]; then
+ exit 2;
+ fi
+done
+
+exit 0;
\ No newline at end of file